<?php

// no direct access
defined('_JEXEC') or die('Restricted access');

$mainframe->registerEvent('onSearch', 'plgSearchJFItems');

JPlugin::loadLanguage('plg_search_jfk2', JPATH_ADMINISTRATOR);

function plgSearchJFItems($text, $phrase = '', $ordering = '', $areas = null) {

	$mainframe = &JFactory::getApplication();

	$db = &JFactory::getDBO();
	$user = &JFactory::getUser();
	$aid = $user->get('aid');

	require_once (JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_search'.DS.'helpers'.DS.'search.php');
	require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'route.php');

	$searchText = $text;
	if (is_array($areas)) {
		if (!array_intersect($areas, array_keys(plgSearchItemsAreas()))) {
			return array();
		}
	}

	$plugin = &JPluginHelper::getPlugin('search', 'jfk2');
	$pluginParams = new JParameter($plugin->params);

	$limit = $pluginParams->def('search_limit', 50);
	$activeLang 	= $pluginParams->def( 'active_language_only', 0);
	
	$text = trim($text);
	if ($text == '') {
		return array();
	}

	$rows = array();

	if ($limit> 0){

		$query = "SELECT i.title AS title,
	    i.metadesc, 
	    i.metakey, 
	    c.name as section, 
	    i.image_caption, 
	    i.image_credits, 
	    i.video_caption, 
	    i.video_credits, 
	    i.extra_fields_search,
	    i.created,
    	CONCAT(i.introtext, i.fulltext) AS text, 
    	CASE WHEN CHAR_LENGTH(i.alias) THEN CONCAT_WS(':', i.id, i.alias) ELSE i.id END as slug, 
    	CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(':', c.id, c.alias) ELSE c.id END as catslug,
    	jfl.code AS jflang, jfl.name AS jflname'
    	FROM #__k2_items AS i
			LEFT JOIN #__jf_content as jfc ON reference_id = i.id
			LEFT JOIN #__languages as jfl ON jfc.language_id = jfl.id
    		INNER JOIN #__k2_categories AS c ON c.id=i.catid AND c.access <= ".$user->get('gid');


		$wheres = array();
		switch ($phrase) {
			case 'exact':
				$text = $db->Quote( '%'.$db->getEscaped( $text, true ).'%', false );
				$where = "LOWER(jfc.value) LIKE ".$text;
			break;
			case 'all':
			case 'any':
			default:
				$words = explode( ' ', $text );
				$wheres = array();
				foreach ($words as $word) {
					$word		= $db->Quote( '%'.$db->getEscaped( $word, true ).'%', false );
					$wheres[] 	= "LOWER(jfc.value) LIKE ".$word;
				}
				$where = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
			break;
		}

		$query.=" WHERE (".$where.")";
		
		$query.=" AND i.trash = 0
	    AND i.published = 1 
	    AND i.access <= ".$aid." 
	    AND c.published = 1 
	    AND c.access <= ".$aid."
	    AND c.trash = 0
		AND jfc.reference_table = 'k2_items'";
		
		if($activeLang)
			$query.=" AND jfl.code = '$lang'";
			
	    $query.=" GROUP BY i.id ";

		switch ($ordering) {
			case 'oldest':
				$query.= 'ORDER BY i.created ASC';
				break;

			case 'popular':
				$query.= 'ORDER BY i.hits DESC';
				break;

			case 'alpha':
				$query.= 'ORDER BY i.title ASC';
				break;

			case 'category':
				$query.= 'ORDER BY c.name ASC, i.title ASC';
				break;

			case 'newest':
			default:
				$query.= 'ORDER BY i.created DESC';
				break;
		}

		$db->setQuery($query, 0, $limit);
		$list = $db->loadObjectList();
		$limit -= count($list);

		if (isset($list)) {
			foreach ($list as $key=>$item) {
				$list[$key]->href = JRoute::_(K2HelperRoute::getItemRoute($item->slug, $item->catslug));

			}
		}
		$rows[] = $list;


	}

	$results = array();
	if (count($rows)) {
		foreach ($rows as $row) {
			
			$results = array_merge($results, (array) $row);
		}
	}

	return $results;
}
